//
//  MSR_ViewController.h
//  iOS
//
//  Created by leesk on 13. 4. 9..
//  Copyright 2013. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "ESCPOSPrinter.h"
#import "CallbackData.h"
#import "EABluetoothPort.h"

#define RGB(r, g, b) [UIColor colorWithRed:r/255.0 green:g/255.0 blue:b/255.0 alpha:1]

@interface MSR_ViewController : UIViewController
{
	UITextField * ipAddressField;
	UITextField * track1Field;
	UITextField * track2Field;
	UITextField * track3Field;
	
	UIButton * openButton;
	UIButton * closeButton;
	UIButton * readMSRButton;	
	UIButton * cancelMSRButton;	
	
	UISegmentedControl * trackSelector;
	int selectedTrack;
	
	ESCPOSPrinter *escp;
}

@property (nonatomic, retain) IBOutlet UITextField * ipAddressField;
@property (nonatomic, retain) IBOutlet UITextField * track1Field;
@property (nonatomic, retain) IBOutlet UITextField * track2Field;
@property (nonatomic, retain) IBOutlet UITextField * track3Field;

@property (nonatomic, retain) IBOutlet UIButton * openButton;
@property (nonatomic, retain) IBOutlet UIButton * closeButton;
@property (nonatomic, retain) IBOutlet UIButton * readMSRButton;
@property (nonatomic, retain) IBOutlet UIButton * cancelMSRButton;

@property (nonatomic, retain) IBOutlet UISegmentedControl * trackSelector;

- (IBAction) connectCommand:(id) sender;

// Read Cancel
- (IBAction) readMSRTestProc:(id) sender;
- (IBAction) cancelMSRTestProc:(id) sender;

- (IBAction) disconnectCommand:(id) sender;
- (IBAction) textFieldDoneEditing:(id) sender;
- (IBAction) backgroundTab:(id) sender;

@end

