//
//  ASBStatus.m
//  iOS
//
//  Created by leesk on 11. 12. 15..
//  Copyright 2011. All rights reserved.
//

#import "ASBStatus.h"
#import "ESCPOSPrinter.h"

@implementation ASBStatus

@synthesize ASB_Normal;
@synthesize ASB_CoverOpen;
@synthesize ASB_PaperNearEmpty;
@synthesize ASB_PaperEmpty;
@synthesize ASB_CashDrawerOpen;


// ASB Status value. [1,3]
const int asb_drawer_close = 4;	//1st
const int asb_cover_open = 32;	//1st
const int asb_paper_near = 3;	//3rd
const int asb_paper_end = 12;	//3rd


- (void) setASBData:(NSData *) data withLength:(int) length
{
	char * status = (char *) [data bytes];
	
	for(int i=0;i<4;i++)
		NSLog(@"ASB [%d] = %d",i,status[i]);
	if((status[0] == 20) && (status[2] == 0))
		ASB_Normal = TRUE;
	else
	{
		ASB_Normal = FALSE;
		if((status[0] & asb_drawer_close) > 0)
			ASB_CashDrawerOpen = FALSE;
		else
			ASB_CashDrawerOpen = TRUE;
	
		if((status[0] & asb_cover_open) > 0)
			ASB_CoverOpen = TRUE;
		else
			ASB_CoverOpen = FALSE;

		if((status[2] & asb_paper_near) > 0)
			ASB_PaperNearEmpty = TRUE;
		else
			ASB_PaperNearEmpty = FALSE;
	
		if((status[2] & asb_paper_end) > 0)
			ASB_PaperEmpty = TRUE;
		else
			ASB_PaperEmpty = FALSE;
	}
}

@end
