//
//  ZPL_ViewController.m
//  iOS
//
//  Created by Sangok OH on 15. 07. 30.
//  Copyright 2015. All rights reserved.
//

int iInterface = -1;

#import "EPL_ViewController.h"

@implementation EPL_ViewController

@synthesize ipAddressField;
@synthesize portNumberField;

@synthesize openButton;
@synthesize closeButton;
@synthesize sample01_Button;
@synthesize sample02_Button;
@synthesize sample03_Button;

- (void) uiToggle:(UIButton*) uiObj mode:(BOOL) mode
{
	if(mode)
	{
		[uiObj setEnabled:TRUE];
		[uiObj setTitleColor:RGB(50,79,133) forState:UIControlStateNormal];
	}
	else
	{
		[uiObj setEnabled:FALSE];
		[uiObj setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];	
	}
}

- (void) setUIConnected:(BOOL) isConnected
{
    // if connected.
	if(isConnected)
	{
		[ipAddressField setEnabled:FALSE];
        [portNumberField setEnabled:FALSE];
        [self uiToggle:openButton mode:FALSE ];
		[self uiToggle:closeButton mode:TRUE];
		[self uiToggle:sample01_Button mode:TRUE];
		[self uiToggle:sample02_Button mode:TRUE];
		[self uiToggle:sample03_Button mode:TRUE];
    }
	else
	{
		[ipAddressField setEnabled:TRUE];
        [portNumberField setEnabled:TRUE];
        [self uiToggle:openButton mode:TRUE];
		[self uiToggle:closeButton mode:FALSE];
		[self uiToggle:sample01_Button mode:FALSE];
		[self uiToggle:sample02_Button mode:FALSE];
		[self uiToggle:sample03_Button mode:FALSE];
	}
}

- (void) messageBox:(NSString *) message withTitle:(NSString *) title
{
	UIAlertView * alert = [[UIAlertView alloc] initWithTitle:title message:message delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil,nil];
	[alert show];
	[alert release];
}

- (IBAction)connectCommand:(id)sender 
{
    int portnum;
    NSString * ip = [ipAddressField text];
	NSLog(@"Connect call\r\n");
    long ret;

    portnum = [[portNumberField text] intValue];

    if( ([ip isEqualToString:@"bluetooth"]) || ([ip isEqualToString:@"Bluetooth"]) )
    { // Bluetooth.
        iInterface = 0;
        ret = [eplPrinter openPort:@"bluetooth" withPortParam:0];
    } else { // tcpip
        iInterface = 1;
        ret = [eplPrinter openPort:ip withPortParam:portnum];
    }
    
#ifdef DEBUG
    NSLog(@"Connect BT Ret %d",ret);
#endif
    if(ret >= 0)
    {
        [self setUIConnected:TRUE];
    }
    else
    {
        [self messageBox:@"Please check the device status or settings." withTitle:@"Connection Failed"];
    }
}

- (IBAction) disconnectCommand: (id) sender 
{
    [eplPrinter closePort];
	NSLog(@"Disconnect call\r\n");
	[self setUIConnected:FALSE];
}

// Print device font
- (IBAction) printTextProc:(id) sender;
{
    // Setup information of printer
    NSLog(@"Start setupPrinter");

    // Korean charset.
    [eplPrinter setEncoding:0x80000422];

    [eplPrinter setupPrinter:@"104" withHeight:@"152" withMedia:LK_EPL_LABEL withGapHeight:@"3" withOffset:@"0" withDensity:8 withSpeed:6 withRotate180:0];

    NSLog(@"Start printDeviceFont");
    [eplPrinter printDeviceFont:400 withY:400 withRotation:0 withFontNumber:3 withHoriExpand:1 withVertExpand:1 withReverse:0 withData:@"SEWOO Label Printer"];
    [eplPrinter printDeviceFont:400 withY:400 withRotation:90 withFontNumber:3 withHoriExpand:1 withVertExpand:1 withReverse:0 withData:@"SEWOO Label Printer"];
    [eplPrinter printDeviceFont:400 withY:400 withRotation:180 withFontNumber:3 withHoriExpand:1 withVertExpand:1 withReverse:0 withData:@"SEWOO Label Printer"];
    [eplPrinter printDeviceFont:400 withY:400 withRotation:270 withFontNumber:3 withHoriExpand:1 withVertExpand:1 withReverse:0 withData:@"SEWOO Label Printer"];
    
    [eplPrinter printDeviceFont:400 withY:960 withRotation:0 withFontNumber:8 withHoriExpand:1 withVertExpand:1 withReverse:0 withData:@"한글 테스트 0도"];
    [eplPrinter printDeviceFont:400 withY:960 withRotation:90 withFontNumber:8 withHoriExpand:1 withVertExpand:1 withReverse:0 withData:@"한글 테스트 90도"];
    [eplPrinter printDeviceFont:400 withY:960 withRotation:180 withFontNumber:8 withHoriExpand:1 withVertExpand:1 withReverse:0 withData:@"한글 테스트 180도"];
    [eplPrinter printDeviceFont:400 withY:960 withRotation:270 withFontNumber:8 withHoriExpand:1 withVertExpand:1 withReverse:0 withData:@"한글 테스트 270도"];
    
    [eplPrinter endPage:1];
}

- (IBAction) barcodeTestProc:(id) sender
{
    NSString *test_str = @"Code128 Auto";
    NSString *code_128a = @"6015343013149";
    int barHeight = 12 * 8; // 12mm

    int gs1x = 500;
    int gs1y = 660;
    int gs1Height = 100;
    NSString * gs1Data = @"[01]98898765432106[3920]15000[3101]000015[17]160210[3202]012345[251]01234567[15]991231";

    
    // Setup information of printer
    [eplPrinter setupPrinter:@"104" withHeight:@"152" withMedia:LK_EPL_LABEL withGapHeight:@"3" withOffset:@"0" withDensity:8 withSpeed:6 withRotate180:0];
    
    // Korean charset.
    [eplPrinter setEncoding:0x80000422];

    [eplPrinter printDeviceFont:80 withY:240 withRotation:0 withFontNumber:3 withHoriExpand:1 withVertExpand:1 withReverse:0 withData:test_str];
    [eplPrinter printBarCode:400 withY:480 withRotation:0 withSymbology:LK_EPL_BCS_128AUTO withNarrowWidth:2 withWideWidth:0 withBarHeight:barHeight withReadable:1 withData:code_128a];
    [eplPrinter printBarCode:384 withY:480 withRotation:90 withSymbology:LK_EPL_BCS_128AUTO withNarrowWidth:2 withWideWidth:0 withBarHeight:barHeight withReadable:1 withData:code_128a];
    [eplPrinter printBarCode:384 withY:464 withRotation:180 withSymbology:LK_EPL_BCS_128AUTO withNarrowWidth:2 withWideWidth:0 withBarHeight:barHeight withReadable:1 withData:code_128a];
    [eplPrinter printBarCode:400 withY:464 withRotation:270 withSymbology:LK_EPL_BCS_128AUTO withNarrowWidth:2 withWideWidth:0 withBarHeight:barHeight withReadable:1 withData:code_128a];
    
    // No readable.
    [eplPrinter printDeviceFont:80 withY:920 withRotation:0 withFontNumber:3 withHoriExpand:1 withVertExpand:1 withReverse:0 withData:@"Human readable=No"];
    [eplPrinter printBarCode:80 withY:960 withRotation:0 withSymbology:LK_EPL_BCS_128AUTO withNarrowWidth:2 withWideWidth:0 withBarHeight:barHeight withReadable:1 withData:code_128a];

    // Readable
    [eplPrinter printDeviceFont:400 withY:920 withRotation:0 withFontNumber:3 withHoriExpand:1 withVertExpand:1 withReverse:0 withData:@"Human readable=Yes"];
    [eplPrinter printBarCode:400 withY:960 withRotation:0 withSymbology:LK_EPL_BCS_128AUTO withNarrowWidth:2 withWideWidth:0 withBarHeight:barHeight withReadable:1 withData:code_128a];
    
    // QR Code
    [eplPrinter printQRCode:40 withY:800 withModel:0 withCellSize:4 withCorrectLevel:0 withData:@"QR Code print"];
    // DataMatrix
    [eplPrinter printDataMatrix:400 withY:800 withRotation:0 withCellSize:4 withData:@"DataMatrix print"];
    // PDF417
    [eplPrinter printDeviceFont:40 withY:80 withRotation:0 withFontNumber:3 withHoriExpand:1 withVertExpand:1 withReverse:0 withData:@"Print PDF417"];
    [eplPrinter printPDF417:40 withY:120 withXTotal:800 withYTotal:400 withXDots:3 withYDots:9 withData:@"PDF417 print" ];
    
    [eplPrinter printGS1:gs1x withY:gs1y withSymbology:6 withMagnification:2 withSepHeight:1 withBarHeight:gs1Height withSegment:22 withLevel:1 withData:gs1Data];

    [eplPrinter endPage:1];
}

- (IBAction) ImageTestProc:(id) sender
{
    // Setup information of printer
    [eplPrinter setupPrinter:@"104" withHeight:@"152" withMedia:LK_EPL_LABEL withGapHeight:@"3" withOffset:@"0" withDensity:8 withSpeed:6 withRotate180:0];
    
    // Korean charset.
    [eplPrinter setEncoding:0x80000422];

    NSString * imgFile2 = [[NSBundle mainBundle] pathForResource:@"sample_2.jpg" ofType:nil];
    NSString * imgFile3 = [[NSBundle mainBundle] pathForResource:@"sample_3.jpg" ofType:nil];
    NSString * imgFile4 = [[NSBundle mainBundle] pathForResource:@"sample_4.jpg" ofType:nil];

    [eplPrinter printImage:imgFile2 withPrintX:1 withPrintY:200 withBrightness:5];
    [eplPrinter printImage:imgFile3 withPrintX:100 withPrintY:10 withBrightness:5];
    [eplPrinter printImage:imgFile4 withPrintX:160 withPrintY:245 withBrightness:5];
    
    [eplPrinter endPage:1];
}

// TextField input done. - hiding keyboard.
- (IBAction) textFieldDoneEditing:(id) sender
{
    [sender resignFirstResponder];
}

- (IBAction) backgroundTab:(id) sender
{
//	NSLog(@"pressed");
	[ipAddressField resignFirstResponder];
}

/////////////////////////////////
// run once at App start.
- (void) viewDidLoad 
{
//    NSLog(@"viewDidLoad");

//    [ipAddressField setText:@"bluetooth"];
    [ipAddressField setText:@"192.168.0.230"];
    [portNumberField setText:@"9100"];
    eplPrinter = [[EPLPrinter alloc] init];
	[self setUIConnected:FALSE];
}
////////////////////////////////

- (void)didReceiveMemoryWarning
{
    [[NSNotificationCenter defaultCenter] removeObserver:self];
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void)dealloc 
{
	[ipAddressField release];
    [portNumberField release];

    [openButton release];
	[closeButton release];
	[sample01_Button release];
	[sample02_Button release];
	[sample03_Button release];

    [eplPrinter release];
    [super dealloc];
}

@end
