//
//  ViewController.m
//  HostSearchTest
//
//  Created by swteam on 7/4/13.
//  Copyright (c) 2013 swteam. All rights reserved.
//

#import "ViewController.h"

#import "POSPrinterFinder.h"
#import "ESCPOSPrinter.h"

@implementation ViewController

@synthesize wifiListTable;
@synthesize refreshButton;

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    // first search.
    
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


//========================================================================//
//          TableView controll
//========================================================================//
- (NSInteger) numberOfSectionsInTableView:(UITableView *)tableView
{
    //NSLog(@"Num of section");
    return 1;
}

// Customize the number of rows in table view.
- (NSInteger) tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger) section
{
    if(wifiList == nil)
        return 0;
    else
        return [wifiList count];
}

// Customize the appearance of table view cells.
- (UITableViewCell *) tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSString * deviceStr;
    static NSString * CellIdentifier = @"Cell";
    UITableViewCell * cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    
    if(cell == nil)
    {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    if(wifiList != nil)
    {
        deviceStr = [[wifiList objectAtIndex:[indexPath row]] objectForKey:@"IP"];
        deviceStr = [deviceStr stringByAppendingFormat:@"   [%@]",[[wifiList objectAtIndex:[indexPath row]] objectForKey:@"MAC"]];
    
        cell.textLabel.text = deviceStr;
        cell.textLabel.font = [UIFont fontWithName:@"Helvetica" size:15];
    }    
    return cell;
}


-(void) tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    long err = 0;
    NSDictionary * wifiData = [wifiList objectAtIndex:[indexPath row]];
    ESCPOSPrinter * printer = [[ESCPOSPrinter alloc] init];
    NSString * ip = [[wifiList objectAtIndex:[indexPath row]] objectForKey:@"IP"];
    if((err = [printer openPort:ip withPortParam:9100]) == 0)
    {
        NSString * printerInfo = [[NSString alloc] init];
        printerInfo = [printerInfo stringByAppendingFormat:@"MAC : %@\n",[wifiData objectForKey:@"MAC"]];
        printerInfo = [printerInfo stringByAppendingFormat:@"IP : %@\n",[wifiData objectForKey:@"IP"]];
        printerInfo = [printerInfo stringByAppendingFormat:@"NETMASK : %@\n",[wifiData objectForKey:@"NETMASK"]];
        printerInfo = [printerInfo stringByAppendingFormat:@"GATEWAY : %@\n",[wifiData objectForKey:@"GATEWAY"]];
        
        // Print
        [printer printString:@"Printer Information\r\n"];
        [printer printString:printerInfo];
        [printer lineFeed:6];
        [printer cutPaper];
        [printer closePort];
    }
    else
    {
        NSLog(@"Connection Failed : %ld",err);
    }
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
}

//========================================================================//
//          Button
//========================================================================//

- (IBAction) refreshProc:(id) sender
{
    POSPrinterFinder * hostfinder = [[POSPrinterFinder alloc] init];
    wifiList = [hostfinder findWiFiHostList];
    if((wifiList != nil) && ([wifiList count] > 0))
    {
        [wifiListTable reloadData];
    }
    else
    {
        NSLog(@"NONE");
    }

    NSLog(@"sizeof(long)=%ld", sizeof(long));
    NSLog(@"sizeof(int)=%ld", sizeof(int));

/*
    int err = 0;
//    NSDictionary * wifiData = [wifiList objectAtIndex:[indexPath row]];
    ESCPOSPrinter * printer = [[ESCPOSPrinter alloc] init];
//    NSString * ip = [[wifiList objectAtIndex:[indexPath row]] objectForKey:@"IP"];
    if((err = [printer openPort:@"192.168.11.165" withPortParam:9100]) == 0)
    {
        NSString * printerInfo = [[NSString alloc] init];
//        printerInfo = [printerInfo stringByAppendingFormat:@"MAC : %@\n",[wifiData objectForKey:@"MAC"]];
//        printerInfo = [printerInfo stringByAppendingFormat:@"IP : %@\n",[wifiData objectForKey:@"IP"]];
//        printerInfo = [printerInfo stringByAppendingFormat:@"NETMASK : %@\n",[wifiData objectForKey:@"NETMASK"]];
//        printerInfo = [printerInfo stringByAppendingFormat:@"GATEWAY : %@\n",[wifiData objectForKey:@"GATEWAY"]];
        printerInfo = [printerInfo stringByAppendingFormat:@"IP : 192.168.11.165\n"];
        
        // Print
        [printer printString:@"Printer Information\r\n"];
        [printer printString:printerInfo];
        [printer lineFeed:6];
        [printer cutPaper];
        [printer closePort];
    }
    else
    {
        NSLog(@"Connection Failed : %d",err);
    }
*/
}

@end
