//
//  POS_ViewController.m
//  iOS
//
//  Created by leesk on 11. 11. 9..
//  Copyright 2011. All rights reserved.
//

#import "POS_ViewController.h"

@implementation POS_ViewController

@synthesize ipAddressField;
@synthesize openButton;
@synthesize closeButton;
@synthesize sample01_Button;
@synthesize sample02_Button;
@synthesize sample03_Button;
@synthesize sample04_Button;
@synthesize sample05_Button;
@synthesize sample06_Button;
@synthesize sample07_Button;
@synthesize sample08_Button;
@synthesize sample09_Button;
@synthesize sample10_Button;
@synthesize sample11_Button;
//@synthesize sample12_Button;

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

unsigned char ResultsCommand[11] = {0x1D,0x28,0x48,0x06,0x00,0x30,0x30,0x46,0x46,0x46,0x46};


// 상태에 따른 UI 설정.
- (void) uiToggle:(UIButton*) uiObj mode:(BOOL) mode
{
	if(mode)
	{
		[uiObj setEnabled:TRUE];
		[uiObj setTitleColor:RGB(50,79,133) forState:UIControlStateNormal];
	}
	else
	{
		[uiObj setEnabled:FALSE];
		[uiObj setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];	
	}
}

- (void) setUIConnected:(BOOL) isConnected
{
	//NSString * a = CPCL_COUNTRY_UK;
	
	// if connected.
	if(isConnected)
	{
		[ipAddressField setEnabled:FALSE];
		[self uiToggle:openButton mode:FALSE ];
		[self uiToggle:closeButton mode:TRUE];	
		[self uiToggle:sample01_Button mode:TRUE];
		[self uiToggle:sample02_Button mode:TRUE];
		[self uiToggle:sample03_Button mode:TRUE];
		[self uiToggle:sample04_Button mode:TRUE];
		[self uiToggle:sample05_Button mode:TRUE];
		[self uiToggle:sample06_Button mode:TRUE];
		[self uiToggle:sample07_Button mode:TRUE];
		[self uiToggle:sample08_Button mode:TRUE];
		[self uiToggle:sample09_Button mode:TRUE];
		[self uiToggle:sample10_Button mode:TRUE];
		[self uiToggle:sample11_Button mode:TRUE];		
		[self uiToggle:sample12_Button mode:TRUE];
	}
	else
	{
		[ipAddressField setEnabled:TRUE];	
		[self uiToggle:openButton mode:TRUE];
		[self uiToggle:closeButton mode:FALSE];	
		[self uiToggle:sample01_Button mode:FALSE];
		[self uiToggle:sample02_Button mode:FALSE];
		[self uiToggle:sample03_Button mode:FALSE];
		[self uiToggle:sample04_Button mode:FALSE];
		[self uiToggle:sample05_Button mode:FALSE];
		[self uiToggle:sample06_Button mode:FALSE];
		[self uiToggle:sample07_Button mode:FALSE];
		[self uiToggle:sample08_Button mode:FALSE];
		[self uiToggle:sample09_Button mode:FALSE];
		[self uiToggle:sample10_Button mode:FALSE];
		[self uiToggle:sample11_Button mode:FALSE];
		[self uiToggle:sample12_Button mode:FALSE];
	}
}

- (void) messageBox:(NSString *) message withTitle:(NSString *) title
{
	UIAlertView * alert = [[UIAlertView alloc] initWithTitle:title message:message delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil,nil];
	[alert show];
	[alert release];
}


// 버튼에 관련된 함수들
- (IBAction)connectCommand:(id)sender 
{
	NSString * ip = [ipAddressField text];	
	NSLog(@"Connect call\r\n");
	long errCode = 0;
	
	if((errCode = [escp openPort:ip withPortParam:9100]) >= 0)
	{
		[self setUIConnected:TRUE];
		NSLog(@"Connection Established\r\n");

    	[escp registerCallback:self withSelctor:@selector(callbackMethod:)];
        [escp asbOn];
    }
	else if(errCode == -3)
	{
		NSLog(@"ERROR: Invalid device\r\n");
	}
	else
	{
		NSLog(@"ERROR: Connection error\r\n");
	}
}

- (IBAction) disconnectCommand: (id) sender 
{
    [escp asbOff];
	[escp closePort];
	NSLog(@"Disconnect call\r\n");
	[self setUIConnected:FALSE];
}

// Sample 01 Button -- 일반 영수증
- (IBAction) sample01Proc:(id) sender;
{
	// Command -- Font Size, Alignment
	unsigned char normalSize[3] = {0x1D,0x21,0x00};
	unsigned char dWidthSize[3] = {0x1D,0x21,0x10};
	unsigned char centerAlign[3] = {0x1B,0x61,0x01};
	unsigned char rightAlign[3] = {0x1B,0x61,0x02};
	
	// read the reference manual enclosed the compressed file.
	NSString* barCodeData = @"21321321321313321";
	unsigned char barCode128[4] = {0x1D,0x6B,0x73,[barCodeData length]};
	unsigned char barCodeWidth[3] = {0x1D,0x77,0x03};
	unsigned char barCodeHeight[3] = {0x1D,0x68,0x85};
	unsigned char barCodeHRI[3] = {0x1D,0x48,0x02};

	[escp printNVBitmap:1 withAlignment:ALIGNMENT_RIGHT withSize:BITMAP_NORMAL];
	[escp printData:dWidthSize withLength:sizeof(dWidthSize)];				   
	[escp printData:centerAlign withLength:sizeof(centerAlign)];				   
	[escp printString:@"Receipt\r\n\r\n"];
	
	[escp printData:normalSize withLength:sizeof(normalSize)];				   
	[escp printData:rightAlign withLength:sizeof(rightAlign)];				   
	[escp printString:@"TEL (123)-456-7890\r\n"];
	
	[escp printData:centerAlign withLength:sizeof(centerAlign)];				   
	[escp printString:@"Thank you for coming to our shop!\r\n\r\n"];
	
	[escp printString:@"Chicken                   $10.00\r\n"];
	[escp printString:@"Hamburger                 $20.00\r\n"];
	[escp printString:@"Pizza                     $30.00\r\n"];
	[escp printString:@"Lemons                    $40.00\r\n"];
	[escp printString:@"Drink                     $50.00\r\n"];
	[escp printString:@"Excluded tax             $150.00\r\n\r\n"];
	
	[escp printData:rightAlign withLength:sizeof(rightAlign)];				   
	[escp printString:@"Tax(5%)                    $7.50\r\n"];
	[escp printString:@"Total                    $157.50\r\n"];
	[escp printString:@"Payment                  $200.00\r\n"];
	[escp printString:@"Change                    $42.50\r\n\r\n\r\n"];
	
	[escp printData:centerAlign withLength:sizeof(centerAlign)];				   
	[escp printData:barCodeWidth withLength:sizeof(barCodeWidth)];
	[escp printData:barCodeHeight withLength:sizeof(barCodeHeight)];
	[escp printData:barCodeHRI withLength:sizeof(barCodeHRI)];
	[escp printData:barCode128 withLength:sizeof(barCode128)];
	[escp printString:barCodeData];
	// 4 Line Feed
	[escp printString:@"\r\n\r\n\r\n\r\n"];	
	[escp cutPaper];

	[escp printData:ResultsCommand withLength:sizeof(ResultsCommand)];
}

// Sample 02 Button -- printText() 사용 
- (IBAction) sample02Proc:(id) sender
{
	unsigned char centerAlign[3] = {0x1B,0x61,0x01};
	
	// read the reference manual enclosed the compressed file.
	NSString* barCodeData = @"21321321321313321";
	
	// 프린터에 저장된 이미지 출력 : 1-255
	[escp printNVBitmap:1 withAlignment:ALIGNMENT_CENTER withSize:BITMAP_NORMAL];
	
	[escp printText:@"Receipt\r\n\r\n" withAlignment:ALIGNMENT_CENTER withOption:FNT_DEFAULT withSize:(TXT_2WIDTH|TXT_1HEIGHT)];	
	[escp printText:@"TEL (123)-456-7890\r\n" withAlignment:ALIGNMENT_RIGHT withOption:FNT_FONTB withSize:TXT_1WIDTH];
	
	[escp printText:@"Thank you for coming to our shop!\r\n\r\n" withAlignment:ALIGNMENT_CENTER withOption:FNT_BOLD withSize:TXT_1WIDTH];
	
	[escp printData:centerAlign withLength:sizeof(centerAlign)];				   
	[escp printString:@"Chicken                   $10.00\r\n"];
	[escp printString:@"Hamburger                 $20.00\r\n"];
	[escp printString:@"Pizza                     $30.00\r\n"];
	[escp printString:@"Lemons                    $40.00\r\n"];
	[escp printString:@"Drink                     $50.00\r\n"];
	[escp printString:@"Excluded tax             $150.00\r\n\r\n"];	
	
	[escp printText:@"Tax(5%)         $7.50\r\n" withAlignment:ALIGNMENT_RIGHT withOption:(FNT_FONTB|FNT_UNDERLINE) withSize:(TXT_1WIDTH)];
	[escp printText:@"Total           $157.50\r\n" withAlignment:ALIGNMENT_RIGHT withOption:(FNT_FONTB|FNT_UNDERLINE) withSize:(TXT_1WIDTH)];
	[escp printText:@"Payment         $200.00\r\n" withAlignment:ALIGNMENT_RIGHT withOption:(FNT_FONTB|FNT_UNDERLINE) withSize:(TXT_1WIDTH)];
	[escp printText:@"Change      $42.50\r\n\r\n\r\n" withAlignment:ALIGNMENT_CENTER withOption:(FNT_UNDERLINE) withSize:(TXT_1WIDTH|TXT_2HEIGHT)];
	
	[escp printBarCode:barCodeData withSymbology:BCS_CODE128 withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	
	// 4 Line Feed
	[escp printString:@"\r\n\r\n\r\n\r\n"];
	[escp cutPaper];

	[escp registerCallback:self withSelctor:@selector(callbackMethod:)];
	[escp printData:ResultsCommand withLength:sizeof(ResultsCommand)];
}


- (IBAction) barcode1DTestProc:(id) sender
{
	NSString * barCodeData = @"123456789012";
	
	[escp printString:@"UPCA\r\n"];
	[escp printBarCode:barCodeData withSymbology:BCS_UPCA withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp printString:@"UPCE\r\n"];
	[escp printBarCode:barCodeData withSymbology:BCS_UPCE withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp printString:@"EAN8\r\n"];
	[escp printBarCode:@"1234567" withSymbology:BCS_EAN8 withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp printString:@"EAN13\r\n"];
	[escp printBarCode:barCodeData withSymbology:BCS_EAN13 withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp printString:@"CODE39\r\n"];
	[escp printBarCode:@"ABCDEFGHI" withSymbology:BCS_CODE39 withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp printString:@"ITF\r\n"];
	[escp printBarCode:barCodeData withSymbology:BCS_ITF withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp printString:@"CODABAR\r\n"];
	[escp printBarCode:barCodeData withSymbology:BCS_CODABAR withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp printString:@"CODE93\r\n"];
	[escp printBarCode:barCodeData withSymbology:BCS_CODE93 withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp printString:@"CODE128\r\n"];
	[escp printBarCode:@"{BNo.{C4567890120" withSymbology:BCS_CODE128 withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp printString:@"\r\n\r\n\r\n"];
	[escp cutPaper];

	[escp printData:ResultsCommand withLength:sizeof(ResultsCommand)];
}

- (IBAction) BitmapTestProc:(id) sender
{
	
	NSString * imgfile1 = [[NSBundle mainBundle] pathForResource:@"sample_1.jpg" ofType:nil];
	NSString * imgfile2 = [[NSBundle mainBundle] pathForResource:@"sample_2.jpg" ofType:nil];
	NSString * imgfile3 = [[NSBundle mainBundle] pathForResource:@"sample_3.jpg" ofType:nil];
	NSString * imgfile4 = [[NSBundle mainBundle] pathForResource:@"sample_4.jpg" ofType:nil];

	[escp printBitmap:imgfile1 withAlignment:ALIGNMENT_CENTER withSize:BITMAP_NORMAL withBrightness:5];
	[escp printBitmap:imgfile2 withAlignment:ALIGNMENT_LEFT withSize:BITMAP_NORMAL withBrightness:5];
	[escp printBitmap:imgfile3 withAlignment:ALIGNMENT_RIGHT withSize:BITMAP_NORMAL withBrightness:5];
	
	[escp printBitmap:imgfile4 withAlignment:ALIGNMENT_LEFT withSize:BITMAP_QUADRUPLE withBrightness:0];
	[escp printBitmap:imgfile4 withAlignment:ALIGNMENT_LEFT withSize:BITMAP_DOUBLE_WIDTH withBrightness:10];
	
	[escp printString:@"\r\n\r\n\r\n\r\n\r\n"];
	[escp cutPaper];

	[escp printData:ResultsCommand withLength:sizeof(ResultsCommand)];
}

- (IBAction) barcode2DTestProc:(id) sender
{
	NSString * barCodeData = @"ABCDEFGHIJKLMN";
	int length = (int)[barCodeData length];
	
	[escp printString:@"PDF417 1\r\n"];
	[escp printPDF417:barCodeData withLength:length withColumns:0 withCellWidth:10 withAlignment:ALIGNMENT_LEFT];
	[escp printString:@"PDF417 2\r\n"];
	[escp printPDF417:barCodeData withLength:length withColumns:0 withCellWidth:20 withAlignment:ALIGNMENT_LEFT];
	[escp printString:@"PDF417 3\r\n"];
	[escp printPDF417:barCodeData withLength:length withColumns:0 withCellWidth:30 withAlignment:ALIGNMENT_LEFT];
	
	[escp printString:@"QR 1\r\n"];
	[escp printQRCode:barCodeData withLength:length withModuleSize:1 withECLevel:0 withAlignment:ALIGNMENT_CENTER];
	[escp printString:@"QR 2\r\n"];
	[escp printQRCode:barCodeData withLength:length withModuleSize:3 withECLevel:0 withAlignment:ALIGNMENT_CENTER];
	[escp printString:@"QR 3\r\n"];
	[escp printQRCode:barCodeData withLength:length withModuleSize:11 withECLevel:0 withAlignment:ALIGNMENT_CENTER];
	[escp printString:@"\r\n\r\n\r\n"];
	[escp cutPaper];

	[escp printData:ResultsCommand withLength:sizeof(ResultsCommand)];
}

- (IBAction) printerStatusProc:(id) sender
{
	long sts = [escp printerSts];
	NSString * result = [[NSString alloc] init];
	
	NSLog(@"Value %ld",sts);
	if([escp asbMode])
		return;
	
	if(sts == STS_NORMAL)
	{
		//NSLog(@"Normal");
		[self messageBox:@"Normal" withTitle:@"Printer Status"];
	}
	else
	{
		if((sts & STS_COVEROPEN) > 0)
		{
			result = [result stringByAppendingString:@"Cover Open\r\n"];
			//NSLog(@"Cover Open");
		}
		if((sts & STS_PAPEREMPTY) > 0)
		{
			result = [result stringByAppendingString:@"Paper Empty\r\n"];
			//NSLog(@"Paper Empty");
		}
		if((sts & STS_PAPERNEAREMPTY) > 0)
		{
			result = [result stringByAppendingString:@"Paper near Empty\r\n"];
			//NSLog(@"Paper Near Empty");
		}
        if((sts & STS_PRINTEROFF) > 0)
        {
			result = [result stringByAppendingString:@"Printer Off\r\n"];
			//NSLog(@"Paper Near Empty");
		}
		[self messageBox:result withTitle:@"Printer Status"];
	}
}

- (IBAction) cashDrawerOpenTestProc:(id) sender
{
	[escp openDrawer:CD_PIN_TWO withPulseOnTime:100 withPulseOffTime:200];
}

- (IBAction) cashDrawerStatusProc:(id) sender
{
	long sts = [escp drawerSts];
	NSLog(@"Drawer Status Value %ld",sts);
	if([escp asbMode])
		return;
	
	if(sts == STS_CD_CLOSE)
	{
		[self messageBox:@"CashDrawer Closed" withTitle:@"CashDrawer Status"];
		//NSLog(@"Close");
	}
	else if(sts == STS_CD_OPEN)
	{
		[self messageBox:@"CashDrawer Opened" withTitle:@"CashDrawer Status"];
		//NSLog(@"Open");	
	}
    else
    {
		[self messageBox:@"Invalid" withTitle:@"CashDrawer Status"];        
    }
}

// AutoStatusBack Test
- (IBAction) ASBOnProc:(id) sender
{
	[escp registerCallback:self withSelctor:@selector(callbackMethod:)];
	[escp asbOn];
}
- (IBAction) ASBOffProc:(id) sender
{
	[escp asbOff];
}


// Korean - CharSet
- (IBAction) KORCharSetTestProc:(id) sender
{
	unsigned char leftAlign[] = "\x1B\x61\x00";
	unsigned char normalSize[] = "\x1D\x21\x00";
	unsigned char doubleSize[] = "\x1D\x21\x11";
	unsigned char dWidthSize[] = "\x1D\x21\x10";
	
	NSString * stringToSend = @"한글 ";
	NSString * stringToSend2 = @"한 TEST\r\n\r\n";
	
	// Encoding Chnage - Korean 
	unsigned char * dataToSend = (unsigned char *) [stringToSend cStringUsingEncoding:0x80000940];
	// Encoding Change - ASCII
	//char * dataToSend = (char *) [stringToSend cStringUsingEncoding:NSASCIIStringEncoding];
	
	// ESCPOS Encoding setting. 
	[escp setEncoding:0x80000940];
	
	[escp printData:leftAlign withLength:3];
	[escp printData:doubleSize withLength:3];
	[escp printData:dataToSend withLength:(int)strlen((const char *) dataToSend)];
	[escp printString:stringToSend2];
	
	[escp printData:dWidthSize withLength:3];
	[escp printData:dataToSend withLength:(int)strlen((const char *) dataToSend)];
	[escp printString:stringToSend2];
	
	[escp printData:normalSize withLength:3];
	[escp printData:dataToSend withLength:(int)strlen((const char *) dataToSend)];
    [escp printString:stringToSend2];
	
	[escp printString:@"\r\n\r\n\r\n\r\n"];
	[escp cutPaper];

	[escp printData:ResultsCommand withLength:sizeof(ResultsCommand)];
}


// BIG5 TEST - CharSet
- (IBAction) BIG5CharSetTestProc:(id) sender
{
	unsigned char * dataToSend;
	NSString * stringToSend = @"下山";
	
	dataToSend = (unsigned char *) [stringToSend cStringUsingEncoding:0x80000a03];
	[escp printData:dataToSend withLength:(int)strlen((const char *) dataToSend)];
	[escp printString:@"\r\n"];
	
	dataToSend = (unsigned char *) [stringToSend cStringUsingEncoding:0x80000a06];
	[escp printData:dataToSend withLength:(int)strlen((const char *) dataToSend)];
	[escp printString:@"\r\n"];
	
	/*
	dataToSend = (char *) [stringToSend cStringUsingEncoding:-2147481085];
	[escp printData:dataToSend withLength:strlen(dataToSend)];	
	[escp printString:@"\r\n\r\n"];
	*/

	[escp printData:ResultsCommand withLength:sizeof(ResultsCommand)];
}

// Keyboard hiding in textbox.
- (IBAction) textFieldDoneEditing:(id) sender
{
	[sender resignFirstResponder];
}

- (IBAction) backgroundTab:(id) sender
{
	// NSLog(@"pressed");
	[ipAddressField resignFirstResponder];
}

/////////////////////////////////
// viewDidLoad method called once when this app started.
- (void) viewDidLoad 
{
	escp = [[ESCPOSPrinter alloc] init];		
	[self setUIConnected:FALSE];
    [ipAddressField setText:@"192.168.0.230"];
}
////////////////////////////////

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc 
{
	[ipAddressField release];
	[openButton release];
	[closeButton release];
	[sample01_Button release];
	[sample02_Button release];
	[sample03_Button release];
	[sample04_Button release];
	[sample05_Button release];	
	[escp release];
    [super dealloc];
}


- (void) callbackMethod:(id)sender
{
	if(sender == nil)
		return;
	
	CallbackData * cbd = (CallbackData *) sender;
	ASBStatus * asbsts = [[ASBStatus alloc] init];
	NSString * result = @"";
	
	NSLog(@"App data Type: %d",[cbd dataType]);
	NSLog(@"App data Length: %d",[cbd dataLength]);

	if([cbd dataLength] == 4)
	{
		[asbsts setASBData:[cbd data] withLength:[cbd dataLength]];
		if(!asbsts.ASB_Normal)
		{
			if(asbsts.ASB_CashDrawerOpen)
			{
				result = [result stringByAppendingString:@"CashDrawer Open\r\n"];
				NSLog(@"CashDrawer Open");
			}
			if(asbsts.ASB_CoverOpen)
			{	
				result = [result stringByAppendingString:@"Cover Open\r\n"];
				NSLog(@"Cover Open");
			}
			if(asbsts.ASB_PaperEmpty)
			{
				result = [result stringByAppendingString:@"Paper Empty\r\n"];
				NSLog(@"Paper Empty");
			}
			if(asbsts.ASB_PaperNearEmpty)
			{
				result = [result stringByAppendingString:@"Paper Near Empty\r\n"];
				NSLog(@"Paper Near Empty");
			}
			[self messageBox:result withTitle:@"AutoStatusBack"];
		}
	} else {
        if([cbd dataLength] == 7)
        {
            result = [result stringByAppendingString:@"Printing complete\r\n"];
            [self messageBox:result withTitle:@"AutoStatusBack"];
        }

    }
}

@end
